local _, ShowQuestXP = ...
ShowQuestXP.Frames = {}
ShowQuestXP.Functions = {}
ShowQuestXP.Events = {}
ShowQuestXP.Data = {}
local function Format_Exp(Exp)
local Var1, Var2, Var3 = string.match(Exp, "^([^%d]*%d)(%d*)(.-)$")
return Var1..(Var2:reverse():gsub("(%d%d%d)", "%1,"):reverse())..Var3
end
local function Get_Bottom(Frames)
local BottomFrame
for _, Frame in ipairs (Frames) do
if (Frame:IsShown()) then
if (Frame:GetName() and Frame:GetTop()) then
if (not BottomFrame) then
BottomFrame = Frame
else
if (Frame:GetTop() < BottomFrame:GetTop()) then BottomFrame = Frame; end
end
end
end
end
return BottomFrame
end
function ShowQuestXP.Functions.Quest_Exp(Exp)
ShowQuestXP.Frames.Exp.Quest.Text:SetText("You will receive: |cffad0e6e"..Format_Exp(Exp).." XP")
ShowQuestXP.Frames.Exp.Quest:ClearAllPoints()
if (QuestInfoRewardsFrame:IsShown()) then ShowQuestXP.Frames.Exp.Quest:SetPoint("TopLeft", QuestInfoRewardsFrame, "BottomLeft", 0, -15); elseif (QuestInfoObjectivesText:IsShown()) then ShowQuestXP.Frames.Exp.Quest:SetPoint("TopLeft", QuestInfoObjectivesText, "BottomLeft", 0, -15); elseif (QuestInfoDescriptionText:IsShown()) then ShowQuestXP.Frames.Exp.Quest:SetPoint("TopLeft", QuestInfoDescriptionText, "BottomLeft", 0, -15); else ShowQuestXP.Frames.Exp.Quest:SetPoint("BottomLeft", 0, -15); end
ShowQuestXP.Frames.Exp.Quest:SetShown(true)
end
function ShowQuestXP.Functions.Log_Exp()
ShowQuestXP.Frames.Exp.Log:SetShown(false)
local Exp = GetQuestLogRewardXP()
if (Exp) then
ShowQuestXP.Frames.Exp.Log.Text:SetText("You will receive: |cffad0e6e"..Format_Exp(Exp).." XP")
ShowQuestXP.Frames.Exp.Log:ClearAllPoints()
local _, Done = IsAddOnLoaded("QuestLogEx")
if (Done) then
if (_G["QuestLogExItem1"]:IsShown()) then
local Index = 2
while _G["QuestLogExItem"..Index] and _G["QuestLogExItem"..Index]:IsShown() do 
Index = Index + 1
end
Index = Index - 1
if (Index % 2 == 0) then Index = Index - 1; end
ShowQuestXP.Frames.Exp.Log:SetPoint("TopLeft", _G["QuestLogExItem"..Index], "BottomLeft", 2, -15)
elseif (_G["QuestLogExItemReceiveText"]:IsShown()) then
ShowQuestXP.Frames.Exp.Log:SetPoint("TopLeft", _G["QuestLogExItemReceiveText"], "BottomLeft", 0, -10)
elseif (_G["QuestLogQuestDescription"]:IsShown()) then
ShowQuestXP.Frames.Exp.Log:SetPoint("TopLeft", _G["QuestLogExQuestDescription"], "BottomLeft", 0, -10)
end
else
if (_G["QuestLogItem1"]:IsShown()) then
local Index = 2
while _G["QuestLogItem"..Index] and _G["QuestLogItem"..Index]:IsShown() do
Index = Index + 1
end
Index = Index - 1
if (Index % 2 == 0) then Index = Index - 1; end
ShowQuestXP.Frames.Exp.Log:SetPoint("TopLeft", _G["QuestLogItem"..Index], "BottomLeft", 2, -15)
elseif (_G["QuestLogItemReceiveText"]:IsShown()) then
ShowQuestXP.Frames.Exp.Log:SetPoint("TopLeft", _G["QuestLogItemReceiveText"], "BottomLeft", 0, -10)
elseif (_G["QuestLogQuestDescription"]:IsShown()) then
ShowQuestXP.Frames.Exp.Log:SetPoint("TopLeft", _G["QuestLogQuestDescription"], "BottomLeft", 0, -10)
end
end
ShowQuestXP.Frames.Exp.Log:SetShown(true)
end
end
function ShowQuestXP.Functions.Complete_Exp(Exp)
ShowQuestXP.Frames.Exp.Complete.Text:SetText("You will receive: |cffad0e6e"..Format_Exp(Exp).." XP")
ShowQuestXP.Frames.Exp.Complete:ClearAllPoints()
if (QuestInfoRewardsFrame:IsShown()) then ShowQuestXP.Frames.Exp.Complete:SetPoint("TopLeft", QuestInfoRewardsFrame, "BottomLeft", 0, -15); elseif (QuestInfoRewardText:IsShown()) then ShowQuestXP.Frames.Exp.Complete:SetPoint("TopLeft", QuestInfoRewardText, "BottomLeft", 0, -15); else ShowQuestXP.Frames.Exp.Complete:SetPoint("BottomLeft", 0, -15); end
ShowQuestXP.Frames.Exp.Complete:SetShown(true)
end
function ShowQuestXP.Functions.Progress_Exp()
ShowQuestXP.Frames.Exp.Progress:SetShown(false)
if (QuestProgressTitleText:IsShown()) then
local NumEntries, isHeader, isCollapsed, Title, Exp, CurrentQuest, QuestTitle
QuestTitle = QuestProgressTitleText:GetText()
local Collapsed = {}
CurrentQuest = GetQuestLogSelection()
NumEntries, _ = GetNumQuestLogEntries()
for i = 1, NumEntries do
_, _, _, isHeader, isCollapsed, _, _, _, _, _, _, _, _, _, _, _, _ = GetQuestLogTitle(i)
if (isHeader and isCollapsed) then table.insert(Collapsed, i); end
end
ExpandQuestHeader(0)
NumEntries, _ = GetNumQuestLogEntries()
for i = 1, NumEntries do
Title, _, _, isHeader, _, _, _, _, _, _, _, _, _, _, _, _, _ = GetQuestLogTitle(i)
if ((not isHeader) and (Title == QuestTitle)) then
SelectQuestLogEntry(i)
Exp = GetQuestLogRewardXP()
break
end
end
for _, v in pairs(Collapsed) do
CollapseQuestHeader(v)
end
SelectQuestLogEntry(CurrentQuest)
if (Exp) then
ShowQuestXP.Frames.Exp.Progress.Text:SetText("You will receive: |cffad0e6e"..Format_Exp(Exp).." XP")
local BottomFrame = Get_Bottom({QuestProgressScrollChildFrame:GetChildren()})
ShowQuestXP.Frames.Exp.Progress:ClearAllPoints()
if (BottomFrame) then
local Left = BottomFrame:GetLeft() - 30
ShowQuestXP.Frames.Exp.Progress:SetPoint("TopLeft", BottomFrame, "BottomLeft", -Left, -15)
else
ShowQuestXP.Frames.Exp.Progress:SetPoint("TopLeft", QuestProgressText, "BottomLeft", 0, -15)
end
ShowQuestXP.Frames.Exp.Progress:SetShown(true)
end
end
end
function ShowQuestXP.Functions.CreateFrames()
ShowQuestXP.Frames.Exp = {}
ShowQuestXP.Frames.Exp.Quest = CreateFrame("Frame")
ShowQuestXP.Frames.Exp.Quest:SetSize(1, 30)
ShowQuestXP.Frames.Exp.Quest:SetParent(QuestDetailScrollChildFrame)
ShowQuestXP.Frames.Exp.Quest.Text = ShowQuestXP.Frames.Exp.Quest:CreateFontString("ARTWORK")
ShowQuestXP.Frames.Exp.Quest.Text:SetFontObject("QuestFont")
ShowQuestXP.Frames.Exp.Quest.Text:SetPoint("TopLeft")
ShowQuestXP.Frames.Exp.Quest:SetShown(false)
ShowQuestXP.Frames.Exp.Log = CreateFrame("Frame")
ShowQuestXP.Frames.Exp.Log:SetSize(1, 30)
local _, Done = IsAddOnLoaded("QuestLogEx")
if (Done and QuestLogExDetailScrollChildFrame) then ShowQuestXP.Frames.Exp.Log:SetParent(QuestLogExDetailScrollChildFrame); else ShowQuestXP.Frames.Exp.Log:SetParent(QuestLogDetailScrollChildFrame); end
ShowQuestXP.Frames.Exp.Log.Text = ShowQuestXP.Frames.Exp.Log:CreateFontString("ARTWORK")
ShowQuestXP.Frames.Exp.Log.Text:SetFontObject("QuestFont")
ShowQuestXP.Frames.Exp.Log.Text:SetPoint("TopLeft")
ShowQuestXP.Frames.Exp.Log:SetShown(false)
ShowQuestXP.Frames.Exp.Complete = CreateFrame("Frame")
ShowQuestXP.Frames.Exp.Complete:SetSize(1, 30)
ShowQuestXP.Frames.Exp.Complete:SetParent(QuestRewardScrollChildFrame)
ShowQuestXP.Frames.Exp.Complete.Text = ShowQuestXP.Frames.Exp.Complete:CreateFontString("ARTWORK")
ShowQuestXP.Frames.Exp.Complete.Text:SetFontObject("QuestFont")
ShowQuestXP.Frames.Exp.Complete.Text:SetPoint("TopLeft")
ShowQuestXP.Frames.Exp.Complete:SetShown(false)
ShowQuestXP.Frames.Exp.Progress = CreateFrame("Frame")
ShowQuestXP.Frames.Exp.Progress:SetSize(1, 30)
ShowQuestXP.Frames.Exp.Progress:SetParent(QuestProgressScrollChildFrame)
ShowQuestXP.Frames.Exp.Progress.Text = ShowQuestXP.Frames.Exp.Progress:CreateFontString("ARTWORK")
ShowQuestXP.Frames.Exp.Progress.Text:SetFontObject("QuestFont")
ShowQuestXP.Frames.Exp.Progress.Text:SetPoint("TopLeft")
ShowQuestXP.Frames.Exp.Progress:SetShown(false)
end
function ShowQuestXP.Functions.CreateEvents()
hooksecurefunc("QuestLog_Update", function()
if (QuestLogFrame:IsShown() or (QuestLogExFrame and QuestLogExFrame:IsShown())) then ShowQuestXP.Functions.Log_Exp(); end
end)
end
ShowQuestXP.Frames.Event = CreateFrame("Frame")
ShowQuestXP.Frames.Event:RegisterEvent("ADDON_LOADED")
ShowQuestXP.Frames.Event:RegisterEvent("PLAYER_LOGIN")
ShowQuestXP.Frames.Event:RegisterEvent("QUEST_DETAIL")
ShowQuestXP.Frames.Event:RegisterEvent("QUEST_COMPLETE")
ShowQuestXP.Frames.Event:RegisterEvent("QUEST_PROGRESS")
function ShowQuestXP.Frames.Event:OnEvent(Event, Self, ...)
if (Event == "ADDON_LOADED" and Self == "ShowQuestXP") then
ShowQuestXP.Data.Title, ShowQuestXP.Data.Version = GetAddOnMetadata(Self, "Title"), GetAddOnMetadata(Self, "Version")
print(" ")
print("|cffffe00a".."(".."|cffff7d0a"..ShowQuestXP.Data.Title, "v"..ShowQuestXP.Data.Version, "|cff69ccf0".."Loaded".."|cffffe00a"..")")
print(" ")
end
if (Event == "PLAYER_LOGIN") then
ShowQuestXP.Frames.Event:UnregisterEvent("PLAYER_LOGIN")
ShowQuestXP.Functions.CreateFrames()
ShowQuestXP.Functions.CreateEvents()
end
if (Event == "QUEST_DETAIL") then
ShowQuestXP.Frames.Exp.Quest:SetShown(false)
local Exp = GetRewardXP()
if (Exp) then ShowQuestXP.Functions.Quest_Exp(Exp); end
end
if (Event == "QUEST_COMPLETE") then
ShowQuestXP.Frames.Exp.Complete:SetShown(false)
local Exp = GetRewardXP()
if (Exp) then ShowQuestXP.Functions.Complete_Exp(Exp); end
end
if (Event == "QUEST_PROGRESS") then
ShowQuestXP.Functions.Progress_Exp()
end
end
ShowQuestXP.Frames.Event:SetScript("OnEvent", ShowQuestXP.Frames.Event.OnEvent)